/* ;
˻ȴ˶ȤʤɡŪİǤʤ(ʤǤʤ)
ɤ뤫ľŪˤ狼ʤ
*/

/* fdisk98.c
 * written by pessi@kmc.kyoto-u.ac.jp
 * thanks for original Linux fdisk.c by A. V. Le Blanc et al.
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation: either version 1 or
 * (at your option) any later version.
 *
 * revised throughout by tak@kmc and ohirune@kmc for Linux/98 beta 
 * release (Revision 1.15 and 1.16)
 *
 * Rev 1.20: ǥν¾ΣϣӤΥѡƥɽ
 *           -l ǥ֡ȤΥե饰θ ID0  ID1 δ㤤
 *
 * Revised throughout (again) by tak@kmc (Revision 1.50)
 */

#define _GNU_SOURCE 1

#ident "$Id: fdisk98.c,v 1.50 2003-02-16 06:25:37+09 tak Exp $"

#include <fcntl.h> /* O_RDWR , open()? */
#include <ctype.h> /* isdigit() */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <unistd.h> /* lseek(), read() */
#include <sys/ioctl.h>
#include <errno.h>
#include <err.h>
#include <locale.h>

#define _LINUX_WAIT_H 1		/* Avoid redefining W* macros.  */
#include <linux/fs.h> /* BLKRRPART (reread partition table) */
#include <linux/hdreg.h> /* HDIO_GETGEO, struct hd_geometry */
#include <scsi/scsi.h>

#undef putchar			/* Keep binary small. */

struct pc98_partition {
	unsigned char mid;	/* 0x80 - active */
	unsigned char sid;
	unsigned char dum1;
	unsigned char dum2;
	unsigned char ipl_sect;	/* IPL sector */
	unsigned char ipl_head;	/* IPL head */
	unsigned short ipl_cyl;	/* IPL cylinder */
	unsigned char sector;	/* starting sector */
	unsigned char head;	/* starting head */
	unsigned short cyl;	/* starting cylinder */
	unsigned char end_sector;/* end sector */
	unsigned char end_head;	/* end head */
	unsigned short end_cyl;	/* end cylinder */
	unsigned char name[16];
};

#define MAX_PART	16
#define MAX_SCSI_PART	15

#define PTBLSIZE 512
#define MAX_CYL 65536

#ifndef PROC_PARTITIONS
# define PROC_PARTITIONS	"/proc/partitions"
#endif

enum print_type { SOFT, HARD, FDISK_COMPAT, VERYSOFT };
enum edit_type  { NEW, EDIT };

/* 98 Υѡƥ ID ΰ̣
 * ƣĤĴΣ蘆ΤŦ󤫤ξˤ
 * id0:
 *  bit 7: 1=boot / 0=bootԲ
 *   # Linux/98Ǥext2/swap̤ͤ롣ɡʤ͡
 *   # ID1  0x62/0x63 ȤˤȤФ褫ä
 *   # (0x83/0x82  MSB ȤΤ)
 *   # Linux/98 ꡼ѤäƤΤϡäܡ
 *  bit 6,5,4: 1=PC-UX,N88,386BSD/NetBSD/FreeBSD
 *             2=DOS,Windows95,WindowsNT,Linux/98
 *             4=Minix, 
 *  bit 3,2,1,0: DOSǤbootǽʤΤ˽֤ˤĤ(system#1,#2,...)
 *               4=PC-UX,386BSD/NetBSD/FreeBSD
 *               0=Minix, Windows95, WindowsNT, DOS(data), Linux/98
 *  # С Linux/98 2.1.57 Ǥ id0=0x62 äWindows95
 *  # fdisk ˾˽񴹤Τǡ¥С󤫤Ϻ ID ѹ
 * id1:
 *  bit 7: 1=active, 0=sleep
 *  bit 6--0:
 *   01H: FAT12
 *   11H: FAT16, <32MB [DOS 3.3 ǥǽ]
 *   21H: FAT16, >=32MB [Large Partition]
 *   31H: NTFS
 *   28H: Windows NT (Volume/Stripe Set?) |
 *   41H: Windows NT (Volume/Stripe Set?) | §̤
 *   48H: Windows NT (Volume/Stripe Set?) |
 *   61H: FAT32
 *   06H: N88-BASIC
 *   04H: PC-UX
 *   44H: 386BSD,NetBSD,FreeBSD
 *   62H: Linux/98 (ext2, swap)
 *
 *  ƣĤĴ٤ˤ Windows95/OSR2/beta3  fdisk ˽񴹤! !
 *
 *  ïOS/2 HPFS ͤ򶵤ƤNTFS ȰǤ
 */

#define LINUX_NATIVE_ID0 0xa0
#define LINUX_NATIVE_ID1 0xe2
#define LINUX_SWAP_ID0 0x20
#define LINUX_SWAP_ID1 0xe2

#define	VT_SAVE_KANJI_MODE	"\033[98;10;1]"
#define	VT_RESTORE_KANJI_MODE	"\033[98;10;2]"

static struct {
  unsigned char id0, id1;
  unsigned char msk0, msk1;
  unsigned char *fdisk_compat_name;
} part_type[] = {
  { LINUX_NATIVE_ID0, LINUX_NATIVE_ID1, 0xff, 0xff, "Linux native" },
  { LINUX_SWAP_ID0,   LINUX_SWAP_ID1,   0xff, 0xff, "Linux swap" },

  { 0,    0,    0xff, 0xff, "Empty ?" },
  { 0x20, 0x01, 0x70, 0x7f, "DOS 12-bit FAT ?" },
  { 0x20, 0x11, 0x70, 0x7f, "DOS 16-bit <32M ?"},
  { 0x20, 0x21, 0x70, 0x7f, "DOS 16-bit >=32M"},
  { 0x20, 0x31, 0x7f, 0x7f, "WindowsNT NTFS"},
  { 0x20, 0x61, 0x7f, 0x7f, "Windows95OSR2 32-bit FAT"},
  { 0x14, 0x04, 0x7f, 0x7f, "PC-UX"},
  { 0x14, 0x44, 0x7f, 0x7f, "*BSD"}
  /* not written */
};

int print_table(struct pc98_partition *p, struct hd_geometry *geom,int type);
int print_partition(int id, struct pc98_partition *p, struct hd_geometry *geom, char *disk_name, int type);
int input_num(char *msg, int defaul);
int input_num_softly(char *msg, int defaul);
int input_yn(int defaul);
int print_geom(struct hd_geometry *geom);
int input_geom(struct hd_geometry *geom);
void print_partition_compat_fdisk(char *devicename);

typedef void *(*dialog_func_t)(int fd, struct hd_geometry *geom, struct pc98_partition *p);

void *dialog_expert(int fd, struct hd_geometry *geom, struct pc98_partition *p);
void *dialog_normal(int fd, struct hd_geometry *geom, struct pc98_partition *p);
int open_dev_getgio_readptbl(char *devname,
			     int flag,
			     struct hd_geometry *geom,
			     unsigned char *ptbuf,
			     size_t ptbuf_size
			     );
const char *print_typename(unsigned char id0,
			   unsigned char id1,
			   int type /* FDISK_COMPAT */
			   );
int edit_partition(int target_part, struct pc98_partition p[], struct hd_geometry *geom, int edittype);
void change_partid(struct pc98_partition *p);
static int is_unused_partition(const struct pc98_partition *);
void pack_and_sort_ptbl(struct pc98_partition *);

/*
 * ȤλѾΥޥå
 *	0  ѤƤ
 *	1  ̤		(!!)
 */
static unsigned char cylmap[MAX_CYL];

static unsigned int user_sectors;
static unsigned int user_heads;
static unsigned int user_cylinders;

int start_cand(struct hd_geometry *geom) {
  int i;
  for (i=0; i<geom->cylinders; i++) {
    if (cylmap[i] != 0) break;
  }
  if (i == geom->cylinders) return -1;
  return i;
}

int end_cand(struct hd_geometry *geom, int start_cyl) {
  int i;
  for (i=start_cyl; i<geom->cylinders; i++) {
    if (cylmap[i] == 0) break;
  }
  return i-1;
}

void set_cylmap(struct hd_geometry *geom, struct pc98_partition *pt) {
  int i,n,s,e;
  for (i=0; i<geom->cylinders; i++) cylmap[i] = 1; /* possibly not used */
  for (/* continuing */; i<MAX_CYL; i++)
      cylmap[i] = 0; /* potentially all used */
  for (n=0; n<MAX_PART; n++) {
    if ((pt[n].mid | pt[n].sid) == 0) continue;
    s = pt[n].ipl_cyl < pt[n].cyl ? pt[n].ipl_cyl : pt[n].cyl;
    e = pt[n].end_cyl;
    for (i=s; i<=e; i++) cylmap[i] = 0; /* actually used */
  }
  cylmap[0] = 0;
}

/* Locale-independent version of `isdigit'. */
#define ISDIGIT(c)	((unsigned int) ((c) - '0') < 10)

static void
list_partitions_compat_fdisk (void)
{
  FILE *partitions = fopen (PROC_PARTITIONS, "r");
  char line[BUFSIZ];
  char ptname[BUFSIZ];

  if (!partitions)
    err (1, "cannot open %s", PROC_PARTITIONS);
  while (fgets (line, sizeof (line), partitions))
    {
      size_t ptlen;

      if (sscanf (line, " %*d %*d %*d %s", ptname) >= 1
	  && (ptlen = strlen (ptname)) && !ISDIGIT (ptname[ptlen - 1]))
	{
	  char devname[sizeof ("/dev/") + ptlen];

	  memcpy (devname, "/dev/", sizeof ("/dev/") - 1);
	  memcpy (devname + sizeof ("/dev/") - 1, ptname, ptlen + 1);
	  print_partition_compat_fdisk (devname);
	}
    }
  if (ferror (partitions))
    err (1, "read error on %s", PROC_PARTITIONS);
  fclose (partitions);
}

static unsigned long
uint_argument (const char *arg, const char *name,
	       unsigned long min, unsigned long max)
{
  unsigned long val;
  char *end;

  if (!name)
    name = "numeric argument";

  errno = 0;
  val = strtoul (arg, &end, 10);
  if (errno || *end || optarg == end)
    errx (2, "invalid %s `%s'", name, arg);
  if (val < min || max < val)
    errx (2, "%s out of range (%lu-%lu)", name, min, max);
  return val;
}

int
main (int argc, char *argv[])
{
  int fd;
  struct hd_geometry geom;
  char *devname = "/dev/hda";
  unsigned char pt[PTBLSIZE];
  dialog_func_t dialog;
  int i=1;
  char *buf, buff[256];
  int optl = 0;

  buf = buff;

  setlocale (LC_ALL, "");

  while ((i = getopt (argc, argv, "C:H:S:lv")) >= 0)
    switch (i)
      {
      case 'C':
	user_cylinders = uint_argument (optarg, "number of cylinders",
					0, 65535);
	break;
      case 'H':
	user_heads = uint_argument (optarg, "number of heads", 0, 255);
	break;
      case 'S':
	user_sectors = uint_argument (optarg, "number of sectors", 0, 255);
	break;
      case 'l':
	optl = 1;
	break;
      case 'v':
	puts("fdisk98 $Revision: 1.50 $");
	return 0;
      default:
	fprintf(stderr, "\
Ȥ: %s ǥХե\n\
        %s -l [ǥХե...]\n",
		argv[0], argv[0]);
	return 2;
      }

  if (optl)
    {
      if (optind >= argc)
	list_partitions_compat_fdisk ();
      else
	for (i = optind; i < argc; i++)
	  print_partition_compat_fdisk (argv[i]);
      return 0;
    }

  if (optind >= argc)
    errx (2, "ǥХե̾ꤵƤޤ");
  else if (optind + 1 < argc)
    errx (2, "ʣΥǥХե̾ꤹ뤳ȤϤǤޤ");
  devname = argv[optind];

  puts(VT_SAVE_KANJI_MODE);

  if ((fd = open_dev_getgio_readptbl(devname, O_RDWR, &geom, pt, sizeof(pt))) < 0) {
    puts(VT_RESTORE_KANJI_MODE);  
    return 1;
  }
  pack_and_sort_ptbl((struct pc98_partition *)pt);
  print_geom(&geom);
  puts("");

//  dialog = dialog_expert;
  dialog = dialog_normal;
  while (dialog != NULL)
    dialog = (*dialog)(fd,&geom,(struct pc98_partition *)pt);
  close(fd);
  puts(VT_RESTORE_KANJI_MODE);  
  return 0;
}

int print_geom(struct hd_geometry *geom) {
  printf("geometry information:\n");
  printf("BIOS geometry (c/h/s, start)= %d, %d, %d, %ld\n",
	 geom->cylinders,
	 geom->heads,
	 geom->sectors,
	 geom->start
	 );
  return 0;
}

int input_geom(struct hd_geometry *geom) {
  printf("geometry input:\n");
  geom->cylinders = input_num(" cylinder", geom->cylinders);
  geom->heads = input_num(" head", geom->heads);
  geom->sectors = input_num(" sector", geom->sectors);
  return 0;
}

int input_num(char *msg, int defaul) {
  unsigned char buf [32];
  char *endptr;
  
  printf("%s<default %d>: ", msg, defaul);
  fgets(buf, sizeof(buf), stdin);
  if (!isdigit(buf[0])) return defaul;
  else return strtoul(buf, &endptr, 0);
}

int input_num_softly(char *msg, int defaul) {
  char buf [32];
  char *endptr;
  
  printf("%s <꥿򲡤 %d Фޤ>: ", msg, defaul);
  fgets(buf, sizeof(buf), stdin);
  if (!isdigit(buf[0])) {
    if (buf[0] == '+') {
      int tmp = strtoul(buf+1, &endptr, 0);
      if (buf+1 < endptr) {
	/* printf("<size %d %c>\n", tmp, *endptr); */
	switch (*endptr) {
	case 'G':  tmp *= 1024;
	case 'M':  tmp *= 1024;
	case 'K':  tmp *= 1024;
	}
	return -tmp;
      }
    }
    return defaul;
  }
  else return strtoul(buf, &endptr, 0);
}

int input_yn(int defaul) {
  unsigned char buf [5];
  
  fgets(buf, sizeof(buf), stdin);
  if ((buf[0]=='Y')||(buf[0]=='y')) return 1;
  if ((buf[0]=='N')||(buf[0]=='n')) return 0;
  return defaul;
}

static void
set_partition_name (struct pc98_partition *part, const char *name)
{
  int i;

  for (i = 0; i < sizeof (part->name) && name[i] && name[i] != '\n'; i++)
    part->name[i] = name[i];
  for (; i < sizeof (part->name); i++)
    part->name[i] = ' ';
}

int input_partition(struct pc98_partition *p) {
  char buf[256];

  p->mid=input_num("id0 (for hex, use 0x...)",p->mid);
  p->sid=input_num("id1 (for hex, use 0x...)",p->sid);
  puts("IPL:");
  p->ipl_cyl  = input_num(" cylinder",p->ipl_cyl );
  p->ipl_head = input_num(" head",p->ipl_head);
  p->ipl_sect = input_num(" sector",p->ipl_sect);
  puts("start:");
  p->cyl   = input_num(" cylinder",p->cyl  );
  p->head  = input_num(" head",p->head );
  p->sector = input_num(" sector",p->sector);
  puts("end:");
  p->end_cyl  = input_num(" cylinder",p->end_cyl );
  p->end_head = input_num(" head",p->end_head);
  p->end_sector = input_num(" sector",p->end_sector);
  
  printf("partition name: ");
  fgets(buf, sizeof(buf), stdin);
  set_partition_name (p, buf);
  return 0;
}

int input_partition_softly(struct pc98_partition *p, struct hd_geometry *geom, int edittype) {
  char buf[256];
  int sysid, start, tmp;

  sysid=input_num_softly("ƥμ [0:Linux native(̾), 1:Linux å), 2:]", 2);
  switch (sysid) {
  case 0:
    p->mid = LINUX_NATIVE_ID0; p->sid = LINUX_NATIVE_ID1; break;
  case 1:
    p->mid = LINUX_SWAP_ID0;   p->sid = LINUX_SWAP_ID1; break;
  default:
    return 1;
  }
  puts("ʲϤ˼ԤƤ⡢θǤγǧߤǤޤ");

  if (edittype == NEW) {
    start = start_cand(geom);
    if (start == -1) {
      puts("ǥ˶̤ޤ"); return 2;
    }
    p->cyl = input_num_softly("ϥ", start_cand(geom));
    p->ipl_cyl = p->cyl;
    p->ipl_head = p->head = 0;
    p->ipl_sect = p->sector = 0;

    printf("λϤƤ\n"
	   "   (Υǥ1礭 %d ХȤǤ)\n\n"
	   "̤ꤷ +10K, +20M, +30G ʤɤȤ\n"
	   "줾 10K, 20M, 30G ХȤ礭ꤵޤ\n\n",
	   geom->heads*geom->sectors*512);
    tmp = input_num_softly("λ( + K/M/G)", end_cand(geom,p->cyl));
    if (tmp < 0) {
      p->end_cyl = -tmp/geom->heads/geom->sectors/512 + p->cyl;
      p->end_cyl = (p->end_cyl>end_cand(geom,p->cyl)) ? end_cand(geom,p->cyl) : p->end_cyl;
    } else p->end_cyl = tmp;
    if (p->end_cyl > end_cand(geom,p->cyl)) {
      puts("礭ޤ");
      return 1;
    }
    if (p->end_cyl < p->cyl) {
      puts("ϥ꽪λˤʤäƤޤ");
      return 1;
    }
    p->end_head = 0;
    p->end_sector = 0;
  }  
  printf("ѡƥ̾(16ʸĶʬڼΤƤޤ): ");
  fgets(buf, sizeof(buf), stdin);
  set_partition_name (p, buf);
  return 0;
}

static void
print_partition_name (const struct pc98_partition *part)
{
  int i;

  for (i = 0; i < sizeof (part->name); i++)
    if ((unsigned char) part->name[i] < ' ')
      {
	putchar ('^');
	putchar ('@' + part->name[i]);
      }
    else
      putchar (part->name[i]);
}

int print_partition(int id, struct pc98_partition *p, struct hd_geometry *geom, char *disk_name, int type) {
  int size;
  switch (type) {
  case HARD:
    printf("#%2d:",id);
    printf("[mid=0x%x, sid=0x%x]"
	   " (C/H/S)=([IPL %d/%d/%d]"
	   " [start %d/%d/%d]"
	   " [end %d/%d/%d])",
	   p->mid, p->sid,
	   p->ipl_cyl, p->ipl_sect, p->ipl_head,
	   p->cyl, p->head, p->sector,
	   p->end_cyl, p->end_head, p->end_sector
	   );
    printf("  <");
    print_partition_name (p);
    printf(">\n");
    break;
  case SOFT:
  case VERYSOFT:
    if ((p->mid | p->sid) == 0) {
      if (is_unused_partition (p)){
        if (type == VERYSOFT) break;
        printf("#%2d:",id);
        printf(" --- ̤(ֹꤹȥѡƥɲäޤ) --- \n");
        break;
      }
      printf("#%2d:",id); 
      printf(" ---  (ȤƤʤȤǧƾäȤ侩) --- \n");
      break;      
    }
    printf("#%2d:",id);
    printf(" <");
    print_partition_name (p);
    putchar('>');
    size = (p->end_cyl-p->cyl+1)*geom->heads*geom->sectors/2;
    if (type == SOFT)
      printf(" ϥ %6d, λ %6d (%5d%c)",
	     p->cyl, p->end_cyl,
	     size<32768 ? size:size/1024, size<32768 ? 'K': 'M'
	     );
    else
            printf(" %7d / %7d (%5d%c)",
	     p->cyl, p->end_cyl,
	     size<32768 ? size:size/1024, size<32768 ? 'K': 'M'
	     );
    printf(" [%s]\n", print_typename(p->mid, p->sid, SOFT));
    break;
  case FDISK_COMPAT:
    if ((p->mid | p->sid) != 0) {
      int nr_sects = (p->end_cyl-p->cyl+1)*geom->heads*geom->sectors;
#if 0
      printf("%*s%-2d  %c%9d%9d%9d%9d%c  %2x  %s\n", w);
#endif
      printf("%-12s" /* device */
	     "%c"    /* boot flag */
	     "%9d%9d%9d"   /* begin, start, end */
	     "%9d%c" /* odd flag on end*/
	     " %2x%2x " /* type id */
	     "%s\n"  /* type name */
	     ,
	     disk_name,
	     (p->mid&0x80) ? '*': ' ' /* ' ', '?' */,
	     p->ipl_cyl, p->cyl, p->end_cyl,
	     nr_sects/2, nr_sects & 1 ? '+' : ' ',
	     p->mid, p->sid,
	     print_typename(p->mid, p->sid, FDISK_COMPAT)
	     );
#if 0
      check_consistency(p, i);
#endif
    }
    break;
  default:
    printf("in print_partition: internal error!\n");
  }
  return 0;
}

int print_table(struct pc98_partition *p, struct hd_geometry *geom,int type) {
  int i, nr_empty = 0, nr_freecyl = 0;
  puts ("");
  if (type == VERYSOFT) {
    puts("ֹ <     ̾ > /λ (  ) [ե륷ƥ]");
  }
  for (i = 0; i < MAX_PART; i++) {
    print_partition(i + 1, &p[i], geom, "", type);
    if (is_unused_partition(&p[i]))
	nr_empty ++;
  }
  if (type == SOFT || type == VERYSOFT){
      if (nr_empty)
	  printf (" %d ĤޤΰݤǤޤ ", nr_empty);
      else
	  printf ("ѡƥơ֥뤬äѤǤ ");
      set_cylmap(geom,p);
      for (i=0; i<geom->cylinders; i++)
	nr_freecyl += cylmap[i];
      printf ("%d (%dͥХ)ζޤ\n",
	      nr_freecyl, nr_freecyl*geom->heads*geom->sectors/2/1024);
  }
  return 0;
}

/* FD  SCSI ǥХΤȤ 1 ֤ */
static int
scsi_device_p (int fd)
{
  unsigned char dummy[16];	/* ºݤˤ Scsi_Idlun 
				   桼ڡǤƤʤ */

  return ioctl (fd, SCSI_IOCTL_GET_IDLUN, dummy) == 0;
}

/* ѡƥơ֥ *PT 򥯥ꥢ */
static void
clear_partition (struct pc98_partition *pt)
{
  memset (pt, '\0', sizeof (*pt) - sizeof (pt->name));
  /* ѡƥ̾ϥڡ */
  memset (pt->name, ' ', sizeof (pt->name));
}

static inline void
clear_partition_table (struct pc98_partition *pt)
{
  int i;

  for (i = 0; i < MAX_PART; i++)
    clear_partition (&pt[i]);
}

void *dialog_expert(int fd, struct hd_geometry *geom, struct pc98_partition *pt) {
  unsigned char buf[256];
  int target_part = MAX_PART;
  
  print_table(pt, geom, HARD);

  while (1) {
    printf("input target number (1-8)\nq (Quit) , w (Write), g (print Geometry) , G (input Geometry) or p(print Partition) :");
    fgets(buf, sizeof(buf), stdin);
    if (isdigit(buf[0])) {
      struct pc98_partition new;
      target_part = atoi(buf);
      printf("target partition = %d\n", target_part);
      assert(1 <= target_part && target_part < MAX_PART);
      print_partition(target_part, &pt[target_part - 1], geom, "", HARD);
      new = pt[target_part - 1];
      input_partition(&new);
      print_table(pt, geom, HARD);
      printf("#%2d old:\n", target_part);
      print_partition(target_part, &pt[target_part - 1], geom, "", HARD);
      printf("#%2d new:\n", target_part);
      print_partition(target_part, &new, geom, "", HARD);
      printf("Ok?(y/n): ");
      fgets(buf, sizeof(buf), stdin);
      if (buf[0] == 'y' || buf[0] == 'Y')
	pt[target_part - 1] = new;
    } else {
      switch (buf[0]) {
      case 'w':
      case 'W':
	printf("Ok?(y/n): ");
	fgets(buf, sizeof(buf), stdin);
	if (buf[0] == 'y' || buf[0] == 'Y') {
	  int ret;
	  lseek(fd, 512, SEEK_SET);
	  ret=write(fd, pt, PTBLSIZE);
	  printf("wrote %d bytes for %d bytes.\n",
		 ret, PTBLSIZE);
	  if (ret == PTBLSIZE) {
	    int i, error = 0 /* just to keep compiler quiet */;
	    /* from original fdisk.c */
	    printf("Calling ioctl() to re-read partition table.\n");
	    sync();
	    sleep(2);
	    if ((i = ioctl(fd, BLKRRPART)) != 0) {
	      error = errno;
	    } else {
	      /* some kernel versions (1.2.x) seem to have trouble
		 rereading the partition table, but if asked to do it
		 twice, the second time works. - biro@yggdrasil.com */
	      sync();
	      sleep(2);
	      if((i = ioctl(fd, BLKRRPART)) != 0)
		error = errno;
	    }

	    printf("Syncing disks.\n");
	    sync();
	    sleep(4);		/* for sync() */

	    if (i < 0)
	      printf("Re-read table failed with error %d: %s.\nReboot your "
		     "system to ensure the partition table is updated.\n",
		     error, strerror(error));

	    goto loop_out;
	  }
	}
	break;
      case 'q':
      case 'Q':
	goto loop_out;
      case 'p':
      case 'P':
	print_table(pt, geom, HARD);
	break;
      case 'g':
	print_geom(geom);
	break;
      case 'G':
	input_geom(geom);
	break;
      default:
	printf("invalid command");
      }
    }
  }
loop_out:
  return NULL;
}

void *dialog_normal(int fd, struct hd_geometry *geom, struct pc98_partition *pt) {
  unsigned char buf[512];
  int target_part = MAX_PART;
  int write_signature = 0;
  int sector_size = -1;
  int is_scsi = scsi_device_p (fd);

#ifdef BLKSSZGET
  if (ioctl (fd, BLKSSZGET, &sector_size))
    sector_size = -1;
#endif

  printf("\x1b[98;0]ܸ PC-98x1 ѡƥԽե $Revision: 1.50 $\n");
  
  if (sector_size < 0)
    printf ("\n[ٹ] ͥ뤫饻Ĺ뤳ȤǤޤǤ\n\
       ");
  else if (sector_size != 512)
    printf ("\nꤵ줿ǥΥĹ %dХ Ǥ\n", sector_size);
  if (sector_size != 512)
    printf ("fdisk98 ϥĹ512ХȤΥǥʳбƤޤ\n");
  if (sector_size >= 0 && sector_size != 512)
    return NULL;

  print_table(pt, geom, VERYSOFT);
  
  /* Ƥ뤫ɤΥå */
  if (lseek (fd, 0, SEEK_SET) < 0 || read (fd, buf, 512) < 512) {
    perror("ǥƬɤ߹Τ˼Ԥޤ");
    return NULL;
  }
  if (buf[510] != 0x55 || buf[511] != 0xaa)
    printf ("[ٹ] ΥǥϽƤޤ\n"
	    "       ˻Ѥˤϡɬפޤ\n");
  else if (memcmp (&buf[4], "IPL1", 4))
    {
      const char *msg = "\
PC-9800꡼ѤΥ֡ȥץब񤭹ޤ\n\
       ޤ";

      if (((buf[0] == 0xEB && !(buf[1] & 0x80))
	   || (buf[0] == 0xE9 && (buf[2] == 0x00 || buf[2] == 0x01)))
	  && memmem (&buf[2], 512 - 4 - 64, "\xCD\x13", 2))
	msg = "\
IBM PCߴѤΥ֡ȥץब񤭹ޤ\n\
       褦Ǥ";

      printf ("[ٹ] \
Υǥˤ%sƥ൯ưѤΥϡɥǥȤƻѤˤϡ\n\
       grub/98 Τ褦ʥ֡ȥץƳɬפޤ\n", msg);
    }

  while (1) {
    printf("\nޥ (hǰɽ) > ");
    fgets(buf, sizeof(buf), stdin);puts("");
    if (isdigit(buf[0])) {
      target_part = atoi(buf);
      if( target_part < 1 || MAX_PART < target_part ) {
	  puts("ѡƥֹ椬Ǥ");
	  continue;
      }
      {
	  register unsigned long * p = (unsigned long *)&pt[target_part - 1];
	  register int i =
	      sizeof(struct pc98_partition) / sizeof(unsigned long);
	  while( *p++ && --i ) ;
	  if( !i ) {
	      puts("ꤵ줿ѡƥϻѤƤޤ");
	      continue;
	  }
      }
      edit_partition(target_part, pt, geom, EDIT);
    } else {
      switch (buf[0]) {
      case 'h': {
	printf("ޥʸޤԽѡƥֹ"
	       "(1-%d)ϤƲ\n\n", MAX_PART);
	puts( "ڥѡƥ  "
	      "n (ɲ),  d (),  t (ID ѹ),  ֹ\n"
	      "       ɽ     "
	      "p (ѡƥޥå),  g (BIOSȥ)\n"
	      "           λ       "
	      "q (Խ̤),	 w (Խ̤񤭹)\n"
	      " Խ⡼  ѹ   "
	      "x (<ѡ>⡼ɤ˰ܹ)\n"
	      "ڥǥ[]  "
	      "f (ѡƥڤӽѤߥե饰)"
	      );
	break;
      }

      case 'n': {
	int i, start;
	printf("\n[ ѡƥ ]\n");
	for (i=0; i<MAX_PART; i++) {
	  if ( is_unused_partition(&pt[i]) ) break;
	}
	if (i >= MAX_PART) {
	  printf("˺ (%d) ΥѡƥꤵƤޤ"
		 "ʾǤޤ\n", MAX_PART);
	  break;
	}
	else if (i >= MAX_SCSI_PART && is_scsi)
	  printf ("
\[ٹ] SCSIǥǤϥѡƥ%dĤޤǤͥǧޤ\n\
       ɲäѡƥLinux饢Ǥʤǽޤ\n",
		  MAX_SCSI_PART);

	set_cylmap(geom,pt);
	start = start_cand(geom);
	if (start == -1) {
	  puts("ǥ˶̤ޤ\n"); break;
	}
	/* i = input_num_softly("ꤹѡƥֹ: ", i + 1); */
	edit_partition(i + 1, pt, geom, NEW);
	if (!(i >= MAX_SCSI_PART && is_scsi))
	  pack_and_sort_ptbl(pt);
	break;
      }
      case 'd': {
	int pi;
	pi = input_num_softly("ѡƥֹ", 0);
	if (pi < 1 || pi > MAX_PART) {
	  puts("ߤޤ");
	  break;
	}
	if( is_unused_partition(&pt[pi - 1]) ) {
	    printf("ѡƥ # %d ꤵƤޤ\n", pi);
	    break;
	}
	print_partition(pi, &pt[pi - 1], geom, "", SOFT);
	printf("Ǥ?(y/n): ");
	fgets(buf, sizeof(buf), stdin);
	if (buf[0] == 'y' || buf[0] == 'Y') {
	  for( ; pi < MAX_PART ; pi++ )
	      pt[pi - 1] = pt[pi];
	  clear_partition (&pt[pi - 1]);
	  set_cylmap(geom,pt);
	}
	else puts("ߤޤ");
	break;
      }
      case 'w':
	printf("Խ̤񤭹ߤޤǤ͡(y/n): ");
	fgets(buf, sizeof(buf), stdin);
	if (buf[0] == 'y' || buf[0] == 'Y') {
	  if (write_signature
	      && (lseek (fd, 0, SEEK_SET) < 0
		  || read (fd, buf, 512) < 512
		  || (buf[510] = 0x55, buf[511] = 0xAA,
		      lseek (fd, 0, SEEK_SET) < 0)
		  || write (fd, buf, 512) < 512))
	    {
	      printf ("Ѥߥե饰ν񤭹ߤ˼Ԥޤ: %s\n",
		      strerror (errno));
	      break;
	    }

	  if (lseek(fd, 512, SEEK_SET) < 0
	      || write(fd, pt, PTBLSIZE) < 0)
	    {
	      printf ("ѡƥơ֥ν񤭹ߤ˼Ԥޤ: %s\n",
		      strerror (errno));
	      break;
	    }

	  /* from original fdisk.c */
	  printf("\
Linux ͥ뤬ѡƥơ֥ǧʤޤ\n\
Ф餯ΤޤޤǤԤ\n");
	  sync();
	  sleep(2);
	  /* ꥸʥ fdisk Ǥ Linux 1.2.x ΥХΤ
	     BLKRRPART 2¹ԤƤ뤬 Linux/98  2.1 ʹߤʤΤ
	     äн褷ʤƤ褤 (Ϥ)  */
	  if (ioctl (fd, BLKRRPART) < 0)
	    printf("\n\
ѡƥơ֥κǧ˼Ԥޤ (顼 %d: %s)\n\
%sLinux ͥϺƵưޤǰΥѡƥơ֥򤽤Τޤ\n\
Ȥ³ޤѡƥơ֥ˤäƥƥ\n\
 (󥹥ȡե륷ƥιۤʤ) ϡ\n\
ƥƵưƤ\n",
		   errno, strerror (errno),
		   errno == EBUSY ? "\
Υǥ˸ߥޥȤƤѡƥ󤬤\n\
ѡƥơ֥κǧϤǤޤ\n" : "");

	  goto loop_out;
	}
	break;
      case 'q':
      case 'Q':
	goto loop_out;
      case 'p':
      case 'P':
	print_table(pt, geom, VERYSOFT);
	break;
      case 'g':
	print_geom(geom);
	break;
      case 't': { /* ѡƥ ID ѹ */
	int pi;
	pi = input_num_softly("ID ѹѡƥֹ", 0);
	if (pi < 1 || pi > MAX_PART) {
	  puts("ߤޤ"); break;
	}
	change_partid(&pt[pi - 1]);
      }
      break;
      case 'x':
	return dialog_expert;
      case 'f':
	puts ("\
\[ٹ] ѡƥơ֥褦ȤƤޤ\n\
       ѡƥơ֥ȡΥǥ¸ߤ\n\
       (ե) Ϥ٤Ƽޤ\n\
\n\
       ǽƤ⡢ w ޥɤǥǥ˽񤭹ޤ\n\
       ºݤΥǥΥѡƥơ֥ѹޤ");
	printf("\n\
Ȥ³ޤ (y/n)");
	if (input_yn(0)==0)
	  break;
	clear_partition_table (pt);
	write_signature = 1;
	puts("\nޤ");
	break;
      default:
	printf("ΥޥɤϤޤ\n");
      }
    }
  }
loop_out:
  return NULL;
}

int edit_partition(int target_part, struct pc98_partition pt[], struct hd_geometry *geom, int edittype ) {
  struct pc98_partition new;
  unsigned char buf[256];
  
  printf("ѡƥ #%d ѹޤ\n:", target_part);
  assert(1 <= target_part && target_part <= MAX_PART);
  print_partition(target_part, &pt[target_part - 1], geom, "", SOFT);
  new = pt[target_part - 1];
  set_cylmap(geom,pt);
  if (input_partition_softly(&new, geom, edittype)) return -1;
  printf("#%2d Խ:\n", target_part);
  print_partition(target_part, &pt[target_part - 1], geom, "", SOFT);
  printf("#%2d Խ:\n", target_part);
  print_partition(target_part, &new, geom, "", SOFT);
  printf("ǤǤ(y/n): ");
  fgets(buf, sizeof(buf), stdin);
  if (buf[0] == 'y' || buf[0] == 'Y')
    pt[target_part - 1] = new;
  set_cylmap(geom,pt);
  return 0;
}

void print_partition_compat_fdisk(char *devicename) {
  int fd, i, w;
  struct hd_geometry geom;
  unsigned char pt[PTBLSIZE];
  char diskname[strlen(devicename)+3];
  
  fd = open_dev_getgio_readptbl(devicename, O_RDONLY, &geom, pt, sizeof(pt));
  if (fd < 0) return;

  pack_and_sort_ptbl((struct pc98_partition *)pt);
  printf("\nDisk %s: %d heads, %d sectors, %d cylinders\n",
         devicename, geom.heads, geom.sectors, geom.cylinders);

  w = strlen(devicename);
  printf("%*s Boot   Begin    Start      End   Blocks   Id  System\n",
	 w + 1, "Device");
  for (i = 0; i < MAX_PART; i++) {
    sprintf(diskname, "%s%d", devicename, i + 1);
    print_partition(i + 1, &((struct pc98_partition *)pt)[i], &geom,
		    diskname, FDISK_COMPAT);
  }
  close(fd);
}

int open_dev_getgio_readptbl(char *devname,
			     int flags,
			     struct hd_geometry *geom,
			     unsigned char *ptbuf,
			     size_t ptbuf_size
			     ) {
  int fd = open(devname, flags);
  int ret;
  if (fd < 0)
    {
      warn ("%s 򥪡ץǤޤ", devname);
      return fd;
    }
  ret = ioctl(fd, HDIO_GETGEO, geom);
  if (ret) {
    warn ("%s ΥȥǤޤ", devname);
    if (!user_cylinders && !user_heads && !user_sectors)
      {
	close(fd);
	return -1;
      }
    memset (geom, '\0', sizeof (struct hd_geometry));
  }
  if (user_cylinders)
    geom->cylinders = user_cylinders;
  if (user_heads)
    geom->heads = user_heads;
  if (user_sectors)
    geom->sectors = user_sectors;

  if (lseek(fd, 512, SEEK_SET) < 0
      || read(fd, ptbuf, ptbuf_size) < (ssize_t) ptbuf_size)
    {
      warn ("%s Υѡƥơ֥ɤ߹ޤ", devname);
      close (fd);
      return -1;
    }
  return fd;
}

const char *print_typename(unsigned char id0,
			   unsigned char id1,
			   int type /* FDISK_COMPAT */
			   ) {
  int i;
  for (i=0; i<sizeof(part_type)/sizeof(part_type[0]); i++)
    if ((id0&part_type[i].msk0) == part_type[i].id0 &&
	(id1&part_type[i].msk1) == part_type[i].id1 )
      return part_type[i].fdisk_compat_name;
  return "unknown";
}

void change_partid(struct pc98_partition *p) {
  int i;
  int max_type = sizeof(part_type)/sizeof(part_type[0]);
  
  printf("ꤵ줿ѡƥθߤΥפ%sǤ\n",
	 print_typename(p->mid, p->sid, SOFT)
	 );
  printf("ʲΥפǤޤ\n");
  for (i=0; i<max_type; i++)
    printf("%2d : %s\n", i, part_type[i].fdisk_compat_name);
  i = input_num_softly("¦ֹꤷƤ", 0);
  if (i<0 || i>=max_type) {
    puts("ߤޤ"); return;
  }
  p->mid = part_type[i].id0;
  p->sid = part_type[i].id1;
  return;
}

/* ѡƥ *PT ʤ鿿Ǥʤе֤
   ξ:
   Ⱦ16ХȤ 0
   
   Ⱦ16ХȤ 0 (NUL)ޤ 0x20 () */
static int
is_unused_partition(const struct pc98_partition *pt)
{
  const unsigned long *lp = (const unsigned long *) pt;
  int i = offsetof (struct pc98_partition, name) / sizeof (unsigned long);

  do
    if (*lp++)
      return 0;
  while (--i);

  if (pt->name[0] != '\0' && pt->name[0] != ' ')
    return 0;
  for (i = 1; i < sizeof (pt->name); i++)
    if (pt->name[i] != pt->name[0])
      return 0;
  return 1;
}

static int partition_compare(const void *a, const void *b)
{
#define	MIN(x,y) ((x)<(y)?(x):(y))

    register const struct pc98_partition * pa = (struct pc98_partition *)a;
    register const struct pc98_partition * pb = (struct pc98_partition *)b;

    if( !pa->sid && !pa->mid )
	return (pb->sid || pb->mid) ? 1 : 0;
    if( !pb->sid && !pb->mid )
	return -1;
    return MIN(pa->ipl_cyl, pa->cyl) - MIN(pb->ipl_cyl, pb->cyl);
}

void pack_and_sort_ptbl(struct pc98_partition * pt)
{
    int i, j;

    /* ̤ѤΥȥͤ */
    for( i = j = 0 ; ; i++, j++ ) {
	while( j < MAX_PART && is_unused_partition(&pt[j]) )
	    j++;
	if( j >= MAX_PART )
	    break;
	if( i != j )
	    pt[i] = pt[j];
    }
    /* ;äȥ0ꥢ */
    for (; i < MAX_PART; i++)
      clear_partition (&pt[i]);

    qsort(pt, i, sizeof(struct pc98_partition), partition_compare);
}
